---
apiVersion: v1
kind: Service
metadata:
  name: taranta-{{ template "taranta.name" . }}-{{ .Release.Name }}
  namespace: {{ .Release.Namespace }}
  labels:
    app: taranta-{{ template "taranta.name" . }}-{{ .Release.Name }}
    chart: {{ template "taranta.chart" . }}
    release: {{ .Release.Name }}
    heritage: {{ .Release.Service }}
spec:
  type: ClusterIP
  ports:
  - name: taranta-http
    port: 80
    protocol: TCP
  selector:
    app: taranta-{{ template "taranta.name" . }}-{{ .Release.Name }}

---
apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: taranta-{{ template "taranta.name" . }}-{{ .Release.Name }}
  namespace: {{ .Release.Namespace }}
  labels:
    app: taranta-{{ template "taranta.name" . }}-{{ .Release.Name }}
    chart: {{ template "taranta.chart" . }}
    release: {{ .Release.Name }}
    heritage: {{ .Release.Service }}
spec:
  selector:
    matchLabels:
      app: taranta-{{ template "taranta.name" . }}-{{ .Release.Name }}
  serviceName: taranta-{{ template "taranta.name" . }}-{{ .Release.Name }}
  replicas: 1
  template:
    metadata:
      labels:
        app: taranta-{{ template "taranta.name" . }}-{{ .Release.Name }}
        chart: {{ template "taranta.chart" . }}
        release: {{ .Release.Name }}
        heritage: {{ .Release.Service }}
    spec:
      containers:
      - name: taranta
        image: "{{ .Values.tarantanode.image.registry }}/{{ .Values.tarantanode.image.image }}:{{ .Values.tarantanode.image.tag }}"
        imagePullPolicy: {{ .Values.tarantanode.image.pullPolicy }}
        stdin: true
        command: ["/bin/sh"]
        args: ["-c", "sh /home/node/app/build.sh"]
        env:
          - name: PORT
            value: "80"
        ports:
        - name: taranta-http
          containerPort: 80
          protocol: TCP
        volumeMounts:
        - name: package-build
          mountPath: /home/node/app/build.sh
          subPath: build.sh
        resources:
{{ toYaml .Values.tarantanode.resources | indent 10 }}
      volumes:
      - name: package-build
        configMap:
          name: taranta-package-build-{{ template "taranta.name" . }}-{{ .Release.Name }}
{{- with .Values.nodeSelector }}
      nodeSelector:
{{ toYaml . | indent 8 }}
{{- end }}
{{- with .Values.affinity }}
      affinity:
{{ toYaml . | indent 8 }}
{{- end }}
{{- with .Values.tolerations }}
      tolerations:
{{ toYaml . | indent 8 }}
{{- end }}

